#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Re-distribution in any form is strictly
//  prohibited. Any infringement will be prosecuted under applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using System.Globalization;

namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.button1.Location = new System.Drawing.Point(464, 72);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(544, 56);
			this.label1.TabIndex = 1;
			this.label1.Text = @"Clicking the button below will result in a new PDF document being generated using Essential PDF.  At the end of the document generation, an option will be provided to view the generated PDF file. Please note that you need to have a PDF viewer installed in order to view the generated PDF file.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 102);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.button1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//Create a new PDF Document. The pdfDoc object represents the PDF document.
			//This document has one page by default and additional pages have to be added.
			PDFDocument pdfDoc = new PDFDocument();

			//Adding a font that can be used to draw Text inside the PDF document.
			//Using the Predefined fonts to draw the text. 
			IPDFFont pdfFont = pdfDoc.Fonts.Add( FontBaseFamily.Courier );
			pdfFont.Size=15;

			//First page Header.
				
			//IPDFGraphicState is used for setting properties of all drawing objects.
			IPDFGraphicState headerProps = pdfDoc.CreateGraphicState();
			headerProps.BackColor = Color.FromArgb(188,220,255);
			
			//Create a Template that can be used as a header
			ITemplate firstpageheader = pdfDoc.CreateTemplate();

			//Draw a Rectangle around the Template Area
			firstpageheader.Graphics.DrawRectangle(new RectangleF(20,0,500,80),headerProps);

			//Filling the Header with text.
			firstpageheader.Graphics.DrawText(pdfDoc.LastPage.PageSize.Width/4,40,"This is a sample Header of Firstpage",pdfFont);
			
			//Assigning the Header to the document.
			pdfDoc.LastPage.Header = firstpageheader;
			

			//First page Footer.
			//Create a Template that can be used as a footer.
			ITemplate firstpagefooter = pdfDoc.CreateTemplate();

			//IPDFGraphicState is used for setting properties of all drawing objects.
			IPDFGraphicState footerProps = pdfDoc.CreateGraphicState();
			footerProps.BackColor = Color.FromArgb(188,220,255) ;

			//Draw a Rectangle around the Template Area
			firstpagefooter.Graphics.DrawRectangle(new RectangleF(20,0,500,50),footerProps);
			
			//Setting location to draw the footer text.
			PointF location = new PointF( 300,20 );

			string text = "Syncfusion";

			//Draw the text at specified location.
			firstpagefooter.Graphics.DrawText( location, text, pdfFont);

			//Measure the size of the text.
			SizeF textSize =  pdfDoc.Graphics.MeasureString(text,pdfFont);
			 
			//Setting the location for Pagenumber to display.
			PointF pageNumberLocation = new PointF(location.X + 2 + textSize.Width,location.Y);
			
			//Draw text at specified location.
			firstpagefooter.Graphics.DrawText(pageNumberLocation,string.Empty,pdfFont );
            
			// Set type of dynamic data.
			//firstpagefooter.LastVariable.DataColumnName =PageDictionaryKeys.PageIndex.ToString( CultureInfo.InvariantCulture);

			//Assigning the footer to the document.
			pdfDoc.LastPage.Footer = firstpagefooter;	

			//Create another page.
			pdfDoc.CreatePage();
			//Header.
				
			//IPDFGraphicState is used for setting properties of all drawing objects.
			IPDFGraphicState headerProps1 = pdfDoc.CreateGraphicState();
			headerProps1.BackColor = Color.FromArgb(188,220,255);
			
			//Create a Template that can be used as a header
			ITemplate header = pdfDoc.CreateTemplate();

			//Draw a Rectangle around the Template Area
			header.Graphics.DrawRectangle(new RectangleF(20,0,500,80),headerProps1);

			//Filling the Header with text.
			header.Graphics.DrawText(pdfDoc.LastPage.PageSize.Width/4,40,"This is a sample Header2",pdfFont);
			
			//Assigning the Header to the document.
			pdfDoc.LastPage.Header = header;
			

			// Footer.
			//Create a Template that can be used as a footer.
			ITemplate footer = pdfDoc.CreateTemplate();

			//IPDFGraphicState is used for setting properties of all drawing objects.
			IPDFGraphicState footerProps1 = pdfDoc.CreateGraphicState();
			footerProps1.BackColor = Color.FromArgb(188,220,255) ;

			//Draw a Rectangle around the Template Area
			footer.Graphics.DrawRectangle(new RectangleF(20,0,500,50),footerProps1);
			
			//Setting location to draw the footer text.
			PointF location1 = new PointF( 300,20 );

			string text1 = "Syncfusion- Page #";

			//Draw the text at specified location.
			footer.Graphics.DrawText( location1, text1, pdfFont);

			//Measure the size of the text.
			SizeF textSize1 =  pdfDoc.Graphics.MeasureString(text1,pdfFont);
			 
			//Setting the location for Pagenumber to display.
			PointF pageNumberLocation1 = new PointF(location1.X + 2 + textSize1.Width,location1.Y);
			
			//Draw text at specified location.
			footer.Graphics.DrawText(pageNumberLocation1,string.Empty,pdfFont );
            
			// Set type of dynamic data.
			footer.LastVariable.DataColumnName =PageDictionaryKeys.PageIndex.ToString( CultureInfo.InvariantCulture);

			//Assigning the footer to the document.
			pdfDoc.LastPage.Footer = footer;	
			 

		
		pdfDoc.Save("Sample.pdf");
			
			//Message box confirmation to view the created PDF document.
			if (MessageBox.Show ("Do you want to view the PDF file?", "PDF File Created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the PDF file using the default Application.[Acrobat Reader]
				System.Diagnostics.Process.Start("Sample.pdf");
				this.Close();
			}
			else
			{
				// Exit
				this.Close();
			}
		}

	}
}
